#pragma once

#include "CoreMinimal.h"
#include "Presenter.h"
#include "UObject/SoftObjectPtr.h"
#include "SettingsCategory.h"
#include "EOverlayTabs.h"
#include "SettingsPresenter.generated.h"

class UUserWidget;
class USettingsMatchDetailsSubPresenter;
class USettingsCategorySubPresenter;
class USubPresenter;
class USettingsViewDataManager;
class USettingsSubCategoryViewData;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIPRESENTERS_API USettingsPresenter : public UPresenter
{
	GENERATED_BODY()

public:
	UPROPERTY(EditAnywhere, BlueprintReadWrite)
	TSoftClassPtr<UUserWidget> SettingsWidgetClass;

private:
	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	USettingsMatchDetailsSubPresenter* _settingsMatchDetailsSubPresenter;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	USettingsCategorySubPresenter* _settingsCategorySubPresenter;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	USubPresenter* _activeSubPresenter;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, meta=(AllowPrivateAccess=true))
	USettingsViewDataManager* _viewDataManager;

protected:
	UFUNCTION(BlueprintCallable)
	void OnTabSelected(const SettingsCategory category);

	UFUNCTION(BlueprintCallable)
	void OnTabEntered(const EOverlayTabs tab, const SettingsCategory category);

private:
	UFUNCTION(BlueprintCallable)
	void OnSubCategorySelected(const USettingsSubCategoryViewData* subCategoryViewData);

protected:
	UFUNCTION(BlueprintCallable)
	void OnResetDefaultsInputSwitcherTriggered();

	UFUNCTION(BlueprintCallable)
	void OnQuitInputSwitcherTriggered();

	UFUNCTION(BlueprintCallable)
	void OnBackInputSwitcherTriggered();

public:
	USettingsPresenter();
};

FORCEINLINE uint32 GetTypeHash(const USettingsPresenter) { return 0; }
